<?php
// Sécurité et récupération des données de configuration
// Mode admin obligatoire (OK=2)
define('OK',2);
include('debut.php');

///////////////////
// Modifications //
///////////////////
if ( isset($_REQUEST['id']) && is_numeric($id = $_REQUEST['id']) )  {
  // Connexion à la base de données
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');
  
  // Vérification que l'identifiant est valide. Défaut : id=0 (nouvelle page)
  if ( $id )  {
    $resultat = $mysqli->query("SELECT id, nom, ordre, (SELECT MAX(p.ordre) FROM pages AS p) AS max FROM pages WHERE id = $id");
    if ( $resultat->num_rows )  {
      $r = $resultat->fetch_assoc();
      $resultat->free();
      $nom = $r['nom'];
      $ordre = $r['ordre'];
    }
    else
      $id = 0;
  }

  // Ajout ou modification d'une page
  if ( isset($_REQUEST['modifie']) )  {
    // Vérification des données envoyées
    if ( !strlen($_REQUEST['titre']) || !strlen($_REQUEST['cle']) || !strlen($_REQUEST['nom']) )
      $message = 'Il n\'est pas possible de valider une page avec une clé, un nom ou un titre vide. Pour supprimer une page, il faut cliquer sur Supprimer.';
    else  {
      // Sauvegarde de la table contenant les données
      sauvegarde_mysql('pages');
      // Validation des données envoyées
      $titre = $mysqli->real_escape_string($_REQUEST['titre']);
      $bandeau = $mysqli->real_escape_string($_REQUEST['bandeau']);
      $cle = $mysqli->real_escape_string($_REQUEST['cle']);
      $nom = $mysqli->real_escape_string($_REQUEST['nom']);
      $protection = ( isset($_REQUEST['protection']) ) ? 1 : 0;
      // Si identifiant numérique non nul, modification d'une page existante
      if ( $id )
        $message = ( $mysqli->query("UPDATE pages SET cle = '$cle', nom = '$nom', titre = '$titre',
                                     bandeau = '$bandeau', protection = $protection WHERE id = $id")
        ) ? 'La page <em>'.stripslashes($nom).'</em> a bien été modifiée.' : "La page <em>${r['nom']}</em> n'a pas pu être modifiée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      // Si id = 0, ajout d'une nouvelle page
      else
        $message = ( $mysqli->query("INSERT INTO pages SET cle = '$cle', nom = '$nom', titre = '$titre',
                                     bandeau = '$bandeau', protection = $protection, ordre = ((SELECT MAX(p.ordre) FROM pages AS p)+1)")
                  && $mysqli->query('ALTER TABLE pages ORDER BY ordre')
        ) ? 'La page «&nbsp'.stripslashes($nom).'</em> a bien été ajoutée.' : 'La page <em>'.stripslashes($nom).'</em> n\'a pas pu être ajoutée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
    }
  }

  elseif ( $id )  {

    // Sauvegarde de la table contenant les données
    sauvegarde_mysql('pages');

    // Déplacement vers le haut
    if ( isset($_REQUEST['monte']) && ( $ordre > 1 ) )
      $message = ( $mysqli->query("UPDATE pages SET ordre = (2*$ordre-1-ordre) WHERE ordre = $ordre OR ordre = ($ordre-1)")
                && $mysqli->query('ALTER TABLE pages ORDER BY ordre')
      ) ? "La page <em>$nom</em> a bien été montée d'une place." : "La page <em>$nom</em> n'a pas pu être déplacée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';

    // Déplacement vers le bas
    elseif ( isset($_REQUEST['descend']) && ( $ordre < $r['max'] ) )
      $message = ( $mysqli->query("UPDATE pages SET ordre = (2*$ordre+1-ordre) WHERE ordre = $ordre OR ordre = ($ordre+1)")
                && $mysqli->query('ALTER TABLE pages ORDER BY ordre')
      ) ? "La page <em>$nom</em> a bien été descendue d'une place." : "La page <em>$nom</em> n'a pas pu être déplacée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';

    // Suppression
    elseif ( isset($_REQUEST['supprime']) && ( $r['max'] > 1 ) )
      $message = ( $mysqli->query("DELETE FROM pages WHERE id = $id")
                && $mysqli->query("DELETE FROM infos WHERE page = $id")
                && $mysqli->query("UPDATE pages SET ordre = (ordre-1) WHERE ordre > $ordre")
      ) ? "La page <em>$nom</em> a bien été supprimée, ainsi que les informations qu'elle comportait." : "La page <em>$nom</em> n'a pas pu être supprimée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';

  }
  $mysqli->close();
}

//////////
// HTML //
//////////
// Haut de page, menu et message
$p = 'pages';
$t = 'Modifications des pages d\'informations';
$mysqli = new mysqli($serveur,$base,$mdp,$base);
$mysqli->set_charset('utf8');
include('haut.php');

?>

  <div class="item aide">
    <h3>Aide et explications</h3>
    <p>Vous pouvez ci-dessous ajouter une page d'information ou modifier les pages existantes ou leur ordre d'apparition dans le menu. Supprimer une page supprime automatiquement les informations qui y sont.</p>
    <h4>Préférences associées à chaque page</h4>
    <ul>
      <li>Le <em>titre</em> sera affiché en haut de page et dans la barre de titre du navigateur. Par exemple, «&nbsp;À propos de l'ADS et du TIPE&nbsp;».</li>
      <li>Le <em>nom dans le menu</em> est affiché dans le menu en tant que lien vers la page. Il est préférable qu'il rentre sur une ligne, il faut donc le choisir assez court. Par exemple, «&nbsp;Informations ADS/TIPE&nbsp;».</li>
      <li>La <em>clé</em> est un mot-clé qui est utilisé uniquement dans l'adresse de la page (<code>http://<?php echo $site; ?>/?[clé]</code>). Il vaut mieux que ce soit un mot unique, court et sans majuscule. Par exemple, «&nbsp;ads-tipe&nbsp;».</li>
      <li>Le <em>texte de début</em> sera affiché au-dessus des informations de la page. Il s'agit d'une ou deux phrases maximum.</li>
    </ul>
    <p>La case à cocher <em>Demande d'identification pour l'affichage de la page </em> permet de restreindre la visibilité de la page aux visiteurs qui se sont identifiés. Dans ce cas, après <a href="utilisateurs">avoir créé un compte pour les élèves ici</a>, ces informations seront accessibles aux élèves auxquels vous aurez donné l'identifiant et le mot de passe choisis.</p>
  </div>

<?php
// Fonction d'affichage
function affichage($r)  {
  // Si l'identifiant est 0, c'est une nouvelle page 
  if ( $id  = $r['id'] )  {
    $debut = "Page n°${r['ordre']}&nbsp;: ${r['nom']}";
    $valide1 = '';
    $valide = "\n      <input type=\"submit\" name=\"modifie\" value=\"Valider\" title=\"Valider les modifications\">";
    $monte = ( $r['ordre'] > 1 ) ? "\n      <input type=\"submit\" name=\"monte\" value=\"&uarr;\" title=\"Remonter la page dans l'ordre d'apparition\">" : '';
    $descend = ( $r['ordre'] < $GLOBALS['max'] ) ? "\n      <input type=\"submit\" name=\"descend\" value=\"&darr;\" title=\"Descendre la page dans l'ordre d'apparition\">" : '';
    $suppr = ( $GLOBALS['max'] > 1 ) ? "\n      <input type=\"submit\" name=\"supprime\" value=\"Supprimer\" title=\"Supprimer la page\">" : '';
  }
  else  {
    $debut = 'Nouvelle page';
    $valide1 = "\n    <input class=\"bouton\" type=\"submit\" name=\"modifie\" value=\"Valider\" title=\"Valider les modifications\">";
    $valide = $monte = $descend = $suppr = '';
  }
  echo <<<FIN
  <div class="item admin">
  <form action="" method="post">$valide1
    <h3>$debut</h3>
    <p class="boutons">$valide$monte$descend$suppr
    </p>
    <p class="ligne"><label for="titre$id">Titre&nbsp;: </label><input type="text" id="titre$id" name="titre" value="${r['titre']}" size="80"></p>
    <p class="ligne"><label for="nom$id">Nom dans le menu&nbsp;: </label><input type="text" id="nom$id" name="nom" value="${r['nom']}" size="50"></p>
    <p class="ligne"><label for="cle$id">Clé dans l'adresse&nbsp;: </label><input type="text" id="cle$id" name="cle" value="${r['cle']}" size="30"></p>
    <p class="ligne"><label for="bandeau$id">Texte de début&nbsp;:</label></p>
    <textarea id="bandeau$id" name="bandeau" rows="2" cols="100">${r['bandeau']}</textarea>
    <p class="ligne"><label for="protection">Demande d'identification pour l'affichage de la page&nbsp;: </label><input type="checkbox" id="protection" name="protection" value="1"${r['protection']}></p>
    <input type="hidden" name="id" value="$id">
  </form>
  </div>


FIN;
}

// Formulaire vide pour une nouvelle page et aide générale
affichage(array('id' => 0, 'cle' => 'cle_de_la_page', 'nom' => 'Nom de la page', 'titre' => 'Titre de la page', 'bandeau' => 'Texte (éventuel) marqué en haut de la page', 'protection' => ''));

// Affichage des pages existantes
$resultat = $mysqli->query('SELECT id,ordre,cle,nom,titre,bandeau,IF(protection=1,\' checked\',\'\') AS protection FROM pages');
$max = $resultat->num_rows;
$mysqli->close();
while ( $r = $resultat->fetch_assoc() )
  affichage($r);
$resultat->free();

// Bas de page
include('bas.php');
?>
