<?php
// Sécurité et récupération des données de configuration
// Mode admin obligatoire (OK=2)
define('OK',2);
include('debut.php');

///////////////////
// Modifications //
///////////////////
if ( isset($_REQUEST['nom']) )  {
  // Connexion à la base de données
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');

  // Sauvegarde de la table contenant les données
  sauvegarde_mysql('utilisateurs');

  // Validation de la matière et de l'identifiant éventuels
  $matiere = $id = 0;
  if ( isset($_REQUEST['matiere']) && is_numeric($_REQUEST['matiere']) )  {
    $resultat = $mysqli->query("SELECT id FROM matieres WHERE id = ${_REQUEST['matiere']}");
    if ( $resultat->num_rows )  {
      $matiere = $_REQUEST['matiere'];
      $resultat->free();
    }
  }
  if ( isset($_REQUEST['id']) && is_numeric($_REQUEST['id']) )  {
    // type = 0 si professeur, 1 si élève
    $resultat = $mysqli->query("SELECT nom, mdp, !matieres AS type FROM utilisateurs WHERE id = ${_REQUEST['id']}");
    if ( $resultat->num_rows )  {
      $id = $_REQUEST['id'];
      $r = $resultat->fetch_assoc();
      $resultat->free();
    }
  }
  
  // Suppression
  if ( ( $id ) && isset($_REQUEST['supprime']) )
    $message = ( $mysqli->query("DELETE FROM utilisateurs WHERE id = $id")
    ) ? "L'utilisateur <em>${r['nom']}</em> a bien été supprimé." : "L'utilisateur <em>${r['nom']}</em> n'a pas pu être supprimé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
  // Modification ou ajout
  elseif ( strlen($nom = $_REQUEST['nom']) && strlen($mdp1 = $_REQUEST['mdp1']) )  {
    $n = ( $id ) ? $r['nom'] : $nom;
    // Vérification que le nouveau nom n'existe pas
    $nom = $mysqli->real_escape_string($nom);
    $resultat = $mysqli->query("SELECT id FROM utilisateurs WHERE nom = '$nom' AND id != $id");
    if ( $resultat->num_rows )  {
      $message = "L'utilisateur <em>$n</em> n'a pas pu être enregistré&nbsp;: un autre utilisateur porte déjà le nom demandé.";
      $resultat->free();
    }
    // Vérification de la concordance des mots de passe
    elseif ( $mdp1 != $_REQUEST['mdp2'] )
      $message = "L'utilisateur <em>$n</em> n'a pas pu être enregistré&nbsp;: les deux mots de passe donnés sont différents.";
    else  {
      $mdp1 = $mysqli->real_escape_string($mdp1);
      // Modification
      if ( $id )  {
        // Vérification du mot de passe actuel (seulement pour les utilisateurs de type professeur)
        if ( ( !$r['type'] ) && ( sha1($_REQUEST['mdp0']) != $r['mdp'] ) )
          $message = "L'utilisateur <em>$n</em> n'a pas pu être enregistré&nbsp;: le mot de passe actuel est incorrect.";
        else
          $message = ( $mysqli->query("UPDATE utilisateurs SET nom = '$nom', mdp = SHA1('$mdp1') WHERE id = $id")
          ) ? "Les données de l'utilisateur <em>$n</em> ont bien été modifiées." : "Les données de l\'utilisateur <em>$n</em> n'ont pas pu être modifiées. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      }
      // Ajout
      else
        $message = ( $mysqli->query("INSERT INTO utilisateurs SET nom = '$nom', mdp = SHA1('$mdp1'), matieres = '$matiere', protection = 0")
        ) ? "L'utilisateur <em>$n</em> a bien été enregistré." : "L'utilisateur <em>$n</em> n'a pas pu être enregistré. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
    }
  }
  
  $mysqli->close();
}

//////////
// HTML //
//////////
// Haut de page, menu et message
$p = 'utilisateurs';
$t = 'Modifications des utilisateurs';
$mysqli = new mysqli($serveur,$base,$mdp,$base);
$mysqli->set_charset('utf8');
include('haut.php');

// Récupération des matières
$resultat = $mysqli->query('SELECT id, nom FROM matieres');
$select_matieres = '';
while ( $r = $resultat->fetch_assoc() )
  $select_matieres .= "        <option value=\"${r['id']}\">${r['nom']}</option>\n";
$resultat->free();

// Aide générale et formulaires
?>

  <div class="item aide">
    <h3>Aide et explications</h3>
    <p>Vous pouvez ci-dessous ajouter un utilisateur, et modifier les utilisateurs existants. Les utilisateurs sont séparés en deux types&nbsp;:</p>
    <ul>
      <li><em>professeur</em>, qui est associé à une matière et permet d'accéder à l'interface d'administration</li>
      <li><em>élève</em>, qui permet uniquement de visualiser les pages et documents qui seraient protégés par une <em>demande d'identification pour visualiser...</em>. Ce choix est à régler individuellement sur chaque page d'informations, individuellement pour chaque répertoire/documents, et dans vos <a href="prefs">préférences</a> pour les programmes de colles/cahier de texte de vos matières associées.</li>
    </ul>
    <p>Une même matière peut être associée à plusieurs utilisateurs de type professeur et chaque professeur peut avoir éventuellement plusieurs matières associées. Ce choix s'effectue dans vos <a href="prefs">préférences</a>.</p>
    <p>L'identifiant ne sert que pour se connecter, il n'est pas accessible aux élèves. Les accents ne posent pas de problème. Un prénom est une bonne idée d'identifiant pour les utilisateurs de type professeur.</p>
    <p>Les mots de passe sont chiffrés avant d'être stockés dans la base de données&nbsp;: il n'y a donc aucun souci sur leur confidentialité. Même l'administrateur du site, l'hébergeur ou d'éventuels pirates ne pourront jamais y avoir accès. Lors de la connexion, le mot de passe entré est chiffré à son tour et ce sont les deux chiffrements qui sont comparés. Attention&nbsp;: il est très dangereux que ce mot de passe soit évident. Un bon mot de passe est un mot de passe d'au moins 8 caractères contenant des lettres, des chiffres et au moins un symbole parmi «&nbsp;?&nbsp;;&nbsp;:&nbsp;!&nbsp;.&nbsp;,-&nbsp;_&nbsp;». Mais vous faîtes ce que vous voulez...</p>
    <p>Pour toutes les modifications d'identifiant ou de mot de passe d'utilisateurs de type professeur, le mot de passe actuel est nécessaire. Il n'est pas nécessaire par contre pour la suppression, afin que le nettoyage des utilisateurs inactifs reste possible depuis l'interface d'administration.</p>
    <p>Ajouter ou supprimer des utilisateurs ne modifie jamais la liste des matières. Pour ajouter ou supprimer des matières, il faut aller sur <a href="matieres">la page correspondante</a>.</p>
  </div>

  <div class="item admin">
  <form action="" method="post" id="ajoute_professeur">
    <input class="bouton" type="submit" name="ajoute" value="Valider" title="Valider les modifications">
    <h3>Créer un nouvel utilisateur (professeur)</h3>
    <p class="ligne"><label for="nom">Nom&nbsp;: </label><input type="text" id="nom" name="nom" value="" size="50"></p>
    <p class="ligne"><label for="mdp1_p">Mot de passe&nbsp;: </label><input type="password" id="mdp1_p" name="mdp1" value=""></p>
    <p class="ligne"><label for="mdp2_p">Confirmation&nbsp;: </label><input type="password" id="mdp2_p" name="mdp2" value=""></p>
    <p class="ligne"><label for="matiere">Matière&nbsp;: </label>
      <select  id="matiere" name="matiere">
<?php echo $select_matieres; ?>
      </select>
    </p>
    <p>La(les) matière(s) associée(s) à cet utilisateur seront modifiables par lui-même une fois qu'il se sera connecté, dans ses <em>préférences</em>. Il est possible de créer une matière <a href="matieres">ici</a>.</p>
  </form>
  </div>

  <script type="text/javascript">
$( function() {
  // Ajout d'un générateur de mot de passe
  $('#ajoute_professeur').append('<p><input type="button" value="Générer un mot de passe" id="generer_mdp">&nbsp;<span></span></p>');
  $('#generer_mdp').click( function () {
    var c = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789,;:!?.';
    var p = '';
    for ( var i = 0 ; i < 8 ; i++ )
      p += c.charAt(1 + Math.floor(Math.random()*68));
    $(this).next('span').html("Valeur recopiée&nbsp;:&nbsp;<code>"+p+"</code>");
    $('#mdp1_p,#mdp2_p').val(p);
  });
});
  </script>

  <div class="item admin">
  <form action="" method="post">
    <input class="bouton" type="submit" name="ajoute" value="Valider" title="Valider les modifications">
    <h3>Créer un nouvel utilisateur (élèves)</h3>
    <p class="ligne"><label for="nom">Nom&nbsp;: </label><input type="text" id="nom" name="nom" value="" size="50"></p>
    <p class="ligne"><label for="mdp1_e">Mot de passe&nbsp;: </label><input type="password" id="mdp1_e" name="mdp1" value=""></p>
    <p class="ligne"><label for="mdp2_e">Confirmation&nbsp;: </label><input type="password" id="mdp2_e" name="mdp2" value=""></p>
  </form>
  </div>

<?php
// Récupération des utilisateurs (et fabrication du select pour l'affichage)
$resultat = $mysqli->query('SELECT u.nom, GROUP_CONCAT(m.nom SEPARATOR \'</em>, <em>\') AS mats FROM utilisateurs AS u JOIN matieres AS m ON FIND_IN_SET(m.id,u.matieres) WHERE u.matieres GROUP BY u.nom ORDER BY u.nom');
$utilisateurs = '';
while ( $r = $resultat->fetch_assoc() )
  $utilisateurs .= "    <li><em>${r['nom']}</em>, associé aux matières <em>${r['mats']}</em></li>\n";
$resultat->free();

// Récupération des utilisateurs

$resultat = $mysqli->query('SELECT u.id, u.nom, GROUP_CONCAT(m.nom SEPARATOR \'</em>, <em>\') AS mats FROM utilisateurs AS u LEFT JOIN matieres AS m ON FIND_IN_SET(m.id,u.matieres) GROUP BY u.nom ORDER BY !u.matieres,u.nom,m.id');
while ( $r = $resultat->fetch_assoc() )  {
  $id = $r['id'];
  if ( $r['mats'] )  {
    $r['mats'] = "\n    <p>Utilisateur de type professeur, associé aux matières <em>${r['mats']}</em></p>";
    $mdp = "\n    <p class=\"ligne\"><label for=\"mdp0_$id\">Mot de passe actuel&nbsp;: </label><input type=\"password\" id=\"mdp0_$id\" name=\"mdp0\" value=\"\"></p>";
  }
  else  {
    $r['mats'] = "\n    <p>Utilisateur de type élève</p>";
    $mdp = '';
  }
  echo <<<FIN
  <div class="item admin">
  <form action="" method="post">
    <input class="bouton" type="submit" name="modifie" value="Valider" title="Valider les modifications">
    <input class="bouton" type="submit" name="supprime" value="Supprimer" title="Supprimer l'utilisateur">
    <h3>Modifier l'utilisateur <em>${r['nom']}</em></h3>${r['mats']}
    <p class="ligne"><label for="nom">Nom&nbsp;: </label><input type="text" id="nom" name="nom" value="${r['nom']}" size="50"></p>$mdp
    <p class="ligne"><label for="mdp1_$id">Mot de passe&nbsp;: </label><input type="password" id="mdp1_$id" name="mdp1" value=""></p>
    <p class="ligne"><label for="mdp2_$id">Confirmation&nbsp;: </label><input type="password" id="mdp2_$id" name="mdp2" value=""></p>
    <input type="hidden" name="id" value="$id">
  </form>
  </div>


FIN;
}
$resultat->free();
$mysqli->close();

// Bas de page
include('bas.php');
?>
